%Calculate the stability of a system whit Homogeneous Lyapunov function.

function [] = robLySearch( A, m )

digits(10);
A = vpa(A);
n = length(A);

%Calculate the possible combination of monomial of degree m.
hState = generateHomogeneousState(m, n);
%Dimension of the homogeneous state vector
d = factorial(n+m-1)/(factorial(n-1)*factorial(m));

[scomposizioneAffineEstesa] = extendedAffine(A, n, m, hState, d);

disp('Inserire i vertici del politopo nella formattazione [value1,value2,...,value3]: (Inserendo x/X termina)');
condition = false;
i = 1;
while condition == false
    value = input('', 's');
    if strcmp(char(value), 'x') || strcmp(char(value), 'X')
        condition = true;
    else
        vertex{i} = eval(value);
        i = i + 1;
    end
end

sigma = 1/2*length(scomposizioneAffineEstesa{1})*(length(scomposizioneAffineEstesa{1})+1)-factorial(n+2*m-1)/(factorial(n-1)*factorial(2*m));

for i=1:sigma*length(vertex)
    alfa{i} = sdpvar(1);
end

warning off;
symL = generateSymsL(n, m, hState, d)
sdpL = generateSdpVarL(symL, length(vertex));
warning on;

for i=1:length(sdpL)
    L{i} = eval(sdpL{i});
    %L{i}
end

for i=1:length(vertex)
    sum = scomposizioneAffineEstesa{1};
    for j=1:length(vertex{i})
        sum = sum + vertex{i}(j)*scomposizioneAffineEstesa{j+1};
    end
    matrixCalculatedOnVertex{i} = sum;
    %matrixCalculatedOnVertex{i}
end

P = sdpvar(length(scomposizioneAffineEstesa{1}));

vincoli = 'set(P > 0) ';
for i=1:length(vertex)
    vincoli = strcat(vincoli, '+ set(matrixCalculatedOnVertex{', num2str(i), '}''*P + P*matrixCalculatedOnVertex{', num2str(i), '} + L{', num2str(i),'} < 0) ');
    matriciPerITest{i} = strcat('double(matrixCalculatedOnVertex{', num2str(i), '}''*P + P*matrixCalculatedOnVertex{', num2str(i), '} + L{', num2str(i),'})');
end

%vincoli
feas = eval(vincoli);
%solvesdp(feas,[], sdpsettings('verbose', 0));
solvesdp(feas);

disp(' ');
if sylvester(double(P))
    disp('La matrice P  simmetrica, definita positiva. Gli autovalori sono:');
else
    disp('La matrice P non  simmetrica, definita positiva. Gli autovalori sono:');
end
vect = eig(double(P));
disp(' ');
for i = 1:length(vect)
    disp(['Lambda', num2str(i), ': ', num2str(vect(i))]);
end

disp(' ');
for i=1:length(vertex)
    if definiteNegative(eval(matriciPerITest{i}))
       disp('Il vincolo  soddisfatto. Gli autovalori sono:');
    else
       disp('Il vincolo non  soddisfatto. Gli autovalori sono:');
    end
    vect = eig(eval(matriciPerITest{i}));
    disp(' ');
    for i = 1:length(vect)
        disp(['Lambda', num2str(i), ': ', num2str(vect(i))]);
    end
end

end
